/******************************************************
*                                                     *
* Input.cpp : Test Idle time                          *
*                                                     *
*  Christian Astor                                   *
*    - Adresse E-mail :     castorix@club-internet.fr *
*    - Adresse ICQ (UIN) :  4396797                   *
*  3 Juin 2000                                       *
*  16 Fvrier 2001 : Ajout boolen pour global hook  *
*                                                     *
******************************************************/

#define _WIN32_WINNT 0x400
#define WINVER 0x0400
#include "stdafx.h"
#include "input.h"
#define WM_INPUT           WM_USER +100

#pragma data_seg ("Shared")
    //HHOOK   g_hHook = NULL;
    HWND    g_hWndNotify = NULL;
#pragma data_seg ()

HHOOK nTabHooks [WH_MAXHOOK];


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch ( ul_reason_for_call )
    {
		case DLL_PROCESS_ATTACH:
			break ;

		case DLL_PROCESS_DETACH:
            break ;

		default :
            break ;
	};
    return TRUE;
}

LRESULT CALLBACK KeyboardProc( int nCode, WPARAM wParam, LPARAM lParam )
{
   	
	if (nCode == HC_ACTION && !(lParam & 0x80000000))
	{
		PostMessage (g_hWndNotify, WM_INPUT, wParam, lParam);
	}
	return nCode < 0 ? CallNextHookEx(nTabHooks[WH_KEYBOARD], nCode, wParam, lParam) : 0;
}


LRESULT CALLBACK MouseProc (int nCode, WPARAM wParam, LPARAM lParam )
{

	if ( nCode >= 0 ) 
	{
		if (nCode == HC_ACTION)
		{
			PostMessage (g_hWndNotify, WM_INPUT, wParam, lParam);
		}
	}
	return nCode < 0 ? CallNextHookEx(nTabHooks[WH_MOUSE], nCode, wParam, lParam) : 0;
}


INPUT_API BOOL RegisterInput( HWND hLocalWnd, BOOL bInstall, BOOL bGlobal)
{
	DWORD dwThreadId;
	if (bGlobal) dwThreadId = 0;
		else dwThreadId = 	GetWindowThreadProcessId(hLocalWnd, NULL);
	if (bInstall)
	{
		if (!nTabHooks[WH_KEYBOARD])
			nTabHooks[WH_KEYBOARD] = SetWindowsHookEx(WH_KEYBOARD , (HOOKPROC)KeyboardProc, GetModuleHandle("INPUT"), dwThreadId);
		if ( nTabHooks[WH_KEYBOARD] == NULL ) return FALSE;
		if (!nTabHooks[WH_MOUSE])
			nTabHooks[WH_MOUSE] = SetWindowsHookEx(WH_MOUSE	, (HOOKPROC)MouseProc, GetModuleHandle("INPUT"), dwThreadId);
		if ( nTabHooks[WH_MOUSE] == NULL ) return FALSE;
				
		g_hWndNotify = hLocalWnd;
	}	
	else
	{
		if (!UnhookWindowsHookEx(nTabHooks[WH_KEYBOARD])) return FALSE; else nTabHooks[WH_KEYBOARD]=NULL;
		if (!UnhookWindowsHookEx(nTabHooks[WH_MOUSE])) return FALSE; else nTabHooks[WH_MOUSE]=NULL;
	}
	return TRUE;
}
